﻿class Edge {
	private var edgeName:String;
	private var nodeOne:Node;
	private var nodeTwo:Node;
	private var currentEdge:Edge;
	private static var edgeList:Array = new Array();
	
	public function Edge(from:Node, to:Node, edgeName:String) {
		nodeOne = from;
		nodeTwo = to;
		
		var edgeKey:String = from.getName() + to.getName();
		var edgePair:Array = new Array();
		
		edgePair.push(edgeKey);
		edgePair.push(this);
		edgeList.push(edgePair);
		
		this.edgeName = edgeName;
		currentEdge = this;
		
		draw(nodeOne, nodeTwo);
	}
	
	public function getName():String {
		return edgeName;
	}
	
	public function getDistance():Number {
		var dx:Number = 0;
		var dy:Number = 0;
		
		dx = Math.abs(nodeOne.getX() - nodeTwo.getX());
		dy = Math.abs(nodeOne.getY() - nodeTwo.getY());
		
		return Math.round(Math.sqrt((dx*dx) + (dy*dy)));
	}
	
	public static function getEdgeList(node1:Node, node2:Node):Array {
		var keyName:String = node1.getName() + node2.getName();
		var gettingEdge:Array = new Array();
		
		for (var i = 0; i < edgeList.length; i++) {
			var itemList:Array = new Array();
			itemList = edgeList[i];
			
			if (itemList[0] == keyName) {
				gettingEdge.push(itemList[1]);
			}
		}
		return gettingEdge;
	}
	
	
	//
	// For drawing the edges. This is not an integral part of the ADT.
	//
	private function draw(node1:Node, node2:Node) {
		var mc1_name:String = "edge" + node1.getName();
		var mc2_name:String = "edge" + node2.getName();
		var line_name:String = "line" + node2.getName();
		
		_root.createEmptyMovieClip(line_name, _root.getNextHighestDepth());
		_root.createEmptyMovieClip(mc1_name, _root.getNextHighestDepth());
		_root.createEmptyMovieClip(mc2_name, _root.getNextHighestDepth());
		
		var lineLoc:MovieClip = eval("_root." + line_name);
		var locOne:MovieClip = eval("_root." + mc1_name);
		var locTwo:MovieClip = eval("_root." + mc2_name);
		
		
		locOne._x = node1.getX();
		locOne._y = node1.getY();
		
		locTwo._x = node2.getX();
		locTwo._y = node2.getY();
		
		/* Used for displaying the edge length next to an edge
		_root.attachMovie("square", "square"+count, _root.getNextHighestDepth());
		var sqObject:MovieClip = eval("square"+count);
		sqObject._x = .5*(locOne._x + locTwo._x);
		sqObject._y = .5*(locOne._y + locTwo._y);
		sqObject.sqText.text = currentEdge.getDistance();
		*/

		with (lineLoc) {
			moveTo(locOne._x, locOne._y);
			lineStyle(1, 0xE4E4E4, 50);
			lineTo(locTwo._x, locTwo._y);
		}
	}
}
