﻿class Node {
	private var nodeName:String;
	private var xPos:Number;
	private var yPos:Number;
	private var neighborList:Array;
	private var currentNode:Node;
	private static var nodeList:Array = new Array();
	
	public function Node(nodeName:String, xPos:Number, yPos:Number) {
		this.nodeName = nodeName;
		this.xPos = xPos;
		this.yPos = yPos;
		nodeList.push(this);
		currentNode = this;
		isSelected = false;
		neighborList = new Array();
		draw(nodeName);
	}

	public function getName():String {
		return nodeName;
	}

	public function getX():Number {
		return xPos;
	}

	public function getY():Number {
		return yPos;
	}
	
	public function getEdgeList(input:Node):Array {
		var newEdge:Array = Edge.getEdgeList(currentNode, input);
		return newEdge;
	}

	public static function getNodes():Array {
		return nodeList;
	}

	public function addEdge(neighbor:Node, edgeName:String) {
		var edgeOne:Edge = new Edge(currentNode, neighbor, edgeName);
		neighborList.push(neighbor);
	}

	public function containsNode(neighbor:Node) {
		var arrayData:Array = currentNode.getNeighbors();
		for (var i = 0; i<arrayData.length; i++) {
			if (arrayData[i] == neighbor) {
				return i;
			}
		}
		return -1;
	}

	public function getNeighbors():Array {
		return neighborList;
	}

	public static function getSelectedNodes():Array {
		nodeSelected = new Array();
		var nodeAll:Array = Node.getNodes();
		for (var i = 0; i<nodeAll.length; i++) {
			var nodeSel:Node = nodeAll[i];
			if (nodeSel.isSelected == true) {
				nodeSelected.push(nodeSel);
			}
		}
		return nodeSelected;
	}
	
	
	//
	// For drawing the nodes. This is not an integral part of the ADT.
	//
	private static var selCount:Number = 0;
	private static var nodeSelected:Array;
	public var isSelected:Boolean = false;
	private function draw(nodeName:String) {
		_root.attachMovie("node_libraryMC", nodeName, _root.getNextHighestDepth());
		var obj:MovieClip = eval("_root."+nodeName);
		obj._x = xPos;
		obj._y = yPos;
		var selectedNode:Node = currentNode;
		obj.onRelease = function() {
			if (selCount<2) {
				if (!selectedNode.isSelected) {
					this._xscale = this._yscale=200;
					selCount++;
					selectedNode.isSelected = true;
					var colorful = new Color(this);
					colorful.setRGB(0xFF9900);
					_root.depthSearch();
				} else {
					this._xscale = this._yscale=100;
					selCount--;
					selectedNode.isSelected = false;
					var colorful = new Color(this);
					colorful.setRGB(0x66CC00);
				}
			} else {
				if (selectedNode.isSelected) {
					_root.redrawScreen();
					this._xscale = this._yscale=100;
					selCount--;
					selectedNode.isSelected = false;
					var colorful = new Color(this);
					colorful.setRGB(0x66CC00);
				}
			}
		};
		obj.onRollOver = function() {
			this.caption.text = nodeName;
		};
		obj.onRollOut = function() {
			this.caption.text = "";
		};
	}
}
